import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.hibernate.cfg.AnnotationConfiguration;
import org.hibernate.cfg.Configuration;
import org.junit.Before;
import org.junit.Test;

import java.io.File;
import java.util.List;

import static org.junit.Assert.assertTrue;


public class Test1 {
    private static Configuration config;
    private static SessionFactory factory;
    private static Session hibernateSession;


    @Before
    public void init() {
        config = new AnnotationConfiguration();
        config.configure(new File("src/main/resources/hibernate.cfg.xml"));
        factory = config.buildSessionFactory();
        hibernateSession = factory.openSession();
    }

    @Test
    public void test() {
        hibernateSession.beginTransaction();

        TestClass3 testClass3First = new TestClass3();
        testClass3First.setName("test3first");
        hibernateSession.persist(testClass3First);

        TestClass3 testClass3Second = new TestClass3();
        testClass3Second.setName("test3second");
        hibernateSession.persist(testClass3Second);

        TestClass2 testClass2 = new TestClass2();
        testClass2.setTitle("test2");
        testClass2.getTestClass3Set().add(testClass3First);
        testClass2.getTestClass3Set().add(testClass3Second);
        hibernateSession.persist(testClass2);

        TestClass1 testClass1 = new TestClass1();
        testClass1.setTitle("test1");
        testClass1.setTestClass2(testClass2);
        hibernateSession.persist(testClass1);

        hibernateSession.flush();

        String query = "from TestClass1 as testClass1 " +
                "where " +
                "testClass1.testClass2.title='test2' and " +
                "exists (from testClass1.testClass2.testClass3Set as testClass3 where testClass3.name = 'test3first')";
        List a = hibernateSession.createQuery(query).list();

        assertTrue(a.size() == 1);
    }
}
